      subroutine cellconstraint
      use constants
      use variables

      call inverse(hmat,hinmat)
      do k=1,n
         qx(k)=hinmat(1,1)*rx(k)+hinmat(1,2)*ry(k)+hinmat(1,3)*rz(k)
         qy(k)=hinmat(2,1)*rx(k)+hinmat(2,2)*ry(k)+hinmat(2,3)*rz(k)
         qz(k)=hinmat(3,1)*rx(k)+hinmat(3,2)*ry(k)+hinmat(3,3)*rz(k)
      enddo
      
      if (cellconstx) then
         hmat(1:3,1)  = hmat0(1:3,1)
         hvmat(1:3,1) = 0.0d0
      endif
      if (cellconsty) then
         hmat(1:3,2)  = hmat0(1:3,2)
         hvmat(1:3,2) = 0.0d0
      endif
      if (cellconstz) then
         hmat(1:3,3)  = hmat0(1:3,3)
         hvmat(1:3,3) = 0.0d0
      endif

      do k=1,n
         rx(k)=hmat(1,1)*qx(k)+hmat(1,2)*qy(k)+hmat(1,3)*qz(k)
         ry(k)=hmat(2,1)*qx(k)+hmat(2,2)*qy(k)+hmat(2,3)*qz(k)
         rz(k)=hmat(3,1)*qx(k)+hmat(3,2)*qy(k)+hmat(3,3)*qz(k)
      enddo

      call calcvolume

      end
