! Fixed atom control

      subroutine fix_atom
      use variables
      use constants
      implicit double precision (a-h,o-z)
      integer i

      do i=1,n
         if (mfx(i)=='F') then;fx(i)=0.0d0;endif
         if (mfy(i)=='F') then;fy(i)=0.0d0;endif
         if (mfz(i)=='F') then;fz(i)=0.0d0;endif
      enddo

      call mkq
      do i=1,n
         if (mfx(i)=='F') then;qx(i)=qpx(i);vx(i)=0.0d0;endif
         if (mfy(i)=='F') then;qy(i)=qpy(i);vy(i)=0.0d0;endif
         if (mfz(i)=='F') then;qz(i)=qpz(i);vz(i)=0.0d0;endif
      enddo
      do i=1,n
         xx=qx(i); yy=qy(i); zz=qz(i)
         rx(i)=hmat(1,1)*xx+hmat(1,2)*yy+hmat(1,3)*zz
         ry(i)=hmat(2,1)*xx+hmat(2,2)*yy+hmat(2,3)*zz
         rz(i)=hmat(3,1)*xx+hmat(3,2)*yy+hmat(3,3)*zz
      enddo

      end subroutine
